
#include "eca.h"

#include <vector>
#include <iostream>


ECA::ECA(int rule, int size)
{
  // Initialize CA size
  this->size = size;

  // Initialize rule table
  for (int i = 0; i < 8; ++i)
  {
    rule_table[i] = rule & 1;
    rule >>= 1;
  }

}


unsigned int ECA::next(unsigned int state)
{
  unsigned int result = 0;

  for (int i = size - 1; i >= 0; --i)
  {
    result <<= 1;

    int rule_index = 0;
    rule_index ^= (state & (1 << ((i + 1) % size)) ? 1 : 0);
    rule_index <<= 1;
    rule_index ^= (state & (1 << i) ? 1 : 0);
    rule_index <<= 1;
    rule_index ^= (state & (1 << ((i + size - 1) % size)) ? 1 : 0);

    result ^= rule_table[rule_index];
  }
  return result;
}


std::vector<bool> ECA::next(std::vector<bool> state)
{
  std::vector<bool> result;
  // FIXME Not implemented.
  return result;
}


void ECA::printState(unsigned int state)
{
  std::cout << '|';
  for (unsigned int mask = (1 << size - 1); mask > 0; mask >>= 1)
  {
    std::cout << (state & mask ? '*' : ' ');
  }
  std::cout << '|' << std::endl;
}


void ECA::printState(std::vector<bool> state)
{
  // FIXME Not implemented.
  std::cout << "ECA vector printout not implemented." << std::endl;
}





