#pragma once

#include <vector>
#include <string>

#define GRAYMAP_MAX_VALUE 256

class Graymap
{
  public:
    void clear();
    void addLine(std::vector<unsigned short>);
    
    void setSize(int width, int height);
    void setWidth(int);
    void setHeight(int);
    
    unsigned short getPixel(int x, int y);
    void setPixel(int x, int y, unsigned short value);

    void writePGM(std::string filename, bool normalized = false);
    void print();
    
    std::vector<std::vector<unsigned short> > getGraymap();
  
  private:
    std::vector<std::vector<unsigned short> > graymap;
    bool isInside(int x, int y);

    unsigned short value_span();
    unsigned short value_max();
    unsigned short value_min();
};

