#include "necklace.h"

#include <iostream>

unsigned int next_necklace(unsigned int size, unsigned int current)
{
  // Special case: Go from a series of 0s to a series of 1s.
  if (current == 0)
  {
    unsigned int next = 0;
    for (int i = 0; i < size; ++i)
    {
      next |= (1 << i);
    }
    return next;
  }

  // generate division table
  // LSB = 1, MSB = 32
  // 1 = divisible by, 0 = not divisible by
  unsigned int division_mask = 0;
  for (unsigned int i = 0; i < size; ++i)
  {
    if (size % (i + 1) == 0)
    {
      division_mask |= (1 << i);
    }
  }

  unsigned int next = current;
  unsigned int j;

  do
  {
    j = 0;
    // find j
    for (unsigned int position = 0; position < size; ++position)
    {
      if (!(next & (1 << position)))
      {
        //std::cout << "c";
        continue;
      }
      j = size - position;
      break;
    }
    
    // create the next "next candidate"
    unsigned int next_next = 0;
    // b_i = a_i for i = 1, 2, ..., j-1
    for (unsigned int position = 1; position < j; ++position)
    {
      next_next |= (next & (1 << (size - position)));
    }
    // b_j = a_j - 1 ( = 0 )
    // b_(j+t) = b_t for t = 1, 2, ..., n-j
    for (unsigned int t = 1; t <= (size - j); ++t)
    {
      next_next |= ((next_next & (1 << (size - t))) >> j);
    }
    next = next_next;
  } while (j and !(division_mask & (1 << (j-1))));

  return next;
}

