#pragma once

#include <stdint.h>

class CA
{
  public:
    CA(uint32_t ca_size, uint64_t rule_number,
        uint32_t rule_radius=1, uint32_t base=2);
    ~CA();

    uint32_t * const ptr(); // get pointer to state
    uint32_t * const next(); // next step & get ptr to state

    void set_state(uint32_t *state); // set state

    void print(); // Print state to stdout.

  private:
    void fill_edges();

    uint32_t size;
    uint32_t base;
    uint64_t rule_number;
    uint32_t rule_radius;
    uint32_t rule_table_size;
    uint32_t * rule_table;
    uint32_t * state;
    uint32_t * extended_state;
};

