#include "convert.h"

#include <cmath>
#include <stdint.h>

#include <iostream>

uint32_t* number2array(uint64_t number, uint32_t base, uint32_t size)
{
  uint32_t* array = new uint32_t[size];

  for (uint32_t i = 0; i < size; ++i)
  {
    array[i] = number % base;
    number /= base;
  }

  return array;
}

uint64_t array2number(uint32_t* array, uint32_t base, uint32_t size)
{
  uint64_t number = 0;

  for (uint32_t i = 0; i < size; ++i)
  {
    number += (array[i] * pow(base, i));
  }

  return number;
}


void number2array(uint64_t number, uint32_t base,
    uint32_t size, uint32_t *array, bool reverse)
{
  if (reverse)
  {
    for (int32_t i = 0; i < size; ++i)
    {
      array[i] = number % base;
      number /= base;
    }
  } else
  {
    for (int32_t i = size-1; i >= 0; --i)
    {
      array[i] = number % base;
      number /= base;
    }
  }
}

void array2number(uint64_t &number, uint32_t base,
    uint32_t size, uint32_t const *array, bool reverse)
{
  number = 0;
  if (reverse)
  {
    for (int32_t i = size-1; i >= 0; --i)
    {
      number *= base;
      number += array[i];
    }
  }else
  {
    for (int32_t i = 0; i < size; ++i)
    {
      number *= base;
      number += array[i];
    }
  }
}

