#include "datapoint.h"

#include <iostream>
#include <string>
#include <sstream>

std::string to_string(Datapoint const *datapoint)
{
  std::stringstream stream;
  stream
    << "(" << datapoint->base << ", " // cellstates / base
    << datapoint->dimensions << ", " // dimensions
    << datapoint->size << ", " // size
    << "\"" << datapoint->neighbourhood << "\"" << ", " // neighbourhood
    << "\"" << datapoint->boundary_condition << "\"" << ", " // boundarycondition
    << datapoint->radius << ", " // range
    << datapoint->rule << ", " // rule
    << "\"" << datapoint->transformation << "\"" << ", " // transformation
    << datapoint->window_size << ", " // windowsize
    << datapoint->start_position << ", " // startposition
    << datapoint->codomain_size << ")" // codomainsize
  ;
  return stream.str();
}

std::string to_sql_string(Datapoint const *datapoint)
{
  std::stringstream stream;
  stream
    << "INSERT INTO data (cellstates, dimensions, size, neighbourhood, "
    << "boundarycondition, range, rule, transformation, windowsize, "
    <<  "startposition, codomainsize) VALUES "
    <<  to_string(datapoint)
    << ";";
  return stream.str();
}

