#pragma once

#include <stdint.h>
#include <string>

struct Datapoint
{
  // General CA options
  uint32_t base; // Number of cell states
  uint32_t dimensions; // CA dimensionality
  uint32_t size; // CA size
  std::string neighbourhood; // CA neighbourhood
  std::string boundary_condition; // Default "cyclic"

  // Specific CA rule options
  uint32_t radius; // Rule radius
  uint64_t rule; // Rule number

  // Transformation options
  std::string transformation; // Transformation employed, default "togglecount"
  uint32_t window_size; // Size of the transform window
  uint32_t start_position; // Start of transform window, in time steps
  
  // Computed data
  uint64_t codomain_size; // Simulation result
};

std::string to_string(Datapoint const *datapoint);
std::string to_sql_string(Datapoint const *datapoint);

